#include "custom_stack.h"

//,      
//      
//  
void void_stack()
{
	printf("      \n");
	printf("  \n");
	exit(1);
}

//,     size
//       ,
//      
void *pmalloc(size_t size)
{
	void *p = malloc(size);
	if (p)
		return p;
	printf(" .   \n");
    exit(1);
}

//,    stack  element
//     
node *push(node *stack, el_type element) 
{
	node *new_node = pmalloc(sizeof(node));       //    
	new_node->element = element;                  // 
    new_node->next = stack;                       // 
    return new_node;                              //   
}

//,     
el_type pop(node **pstack)                     //   pstack, 
{                                              //,     
	if (*pstack)                               //  
	{
		node *first_node = *pstack;             // 1-  
		*pstack = first_node->next;             //    2- 
		el_type element = first_node->element;  //  1-    
		free(first_node);                       // 
		return element;                         //   
    }
    void_stack();                               //  ,    
}

//,        
el_type peek(node *stack)
{
	if (stack)
		return stack->element;
	void_stack();                             //  ,    		
}

//,   ,   
int count(node *stack)
{
	int i = 0;
	for(; stack; i++)
		stack = stack->next;
	return i;
}

//,  
node *invert(node *stack)
{
	if (!stack)
		return 0;
	node *stack2 = stack->next, *temp;
	stack->next = 0;
	while (stack2)
	{
		temp = stack2->next;
		stack2->next = stack;
		stack = stack2;
		stack2 = temp;
	}
	return stack;
}

//,      
char *print_down(node *stack, char *string, int max_size,
                 char *(*print_element) (el_type element))
{
	if (!stack)
	{
		snprintf(string, max_size, "{}");
		return string;
	}
	char *str = string, *str2;
	int c;
	snprintf(string++, max_size--, "{");
	while (stack)
	{
		c = snprintf(string, max_size, "%s, ", str2 = (*print_element) (stack->element));
		free(str2);
		string += c;
		max_size -= c;
		stack = stack->next;
	}
	snprintf(string - 2, max_size + 2, "}");
	return str;
}

//,      
char *print_up(node *stack, char *(*print_element) (el_type element))
{
	if (!stack)
	{
		char *string = pmalloc(3);
		sprintf(string, "{}");
		return string;
	}
	int i = 0, j = 0;
	char *strings[count(stack)];
	char *string, *str;
	while (stack)
	{
		strings[i++] = str = (*print_element) (stack->element);
		j += strlen(str);
		stack = stack->next;
	}
	str = string = pmalloc(j + 2 * i + 1);
	sprintf(string++, "{");
	while (--i)
	{
		string += sprintf(string, "%s, ", strings[i]);
	    free(strings[i]);
	}
	sprintf(string, "%s}", strings[0]);
	free(strings[0]);
	return str;
}
